ILOGB(3)

NAME
ilogb, ilogbf, ilogbl - get integer exponent of a floating-point value

SYNOPSIS
#include <math.h>

int ilogb(double x);
int ilogbf(float x);
int ilogbl(long double x);

Link with -lm.

Feature Test Macro Requirements for glibc (see feature_test_macros(7)):

ilogb(): _BSD_SOURCE || _SVID_SOURCE || _XOPEN_SOURCE >= 500 || _ISOC99_SOURCE; or cc -std=c99
ilogbf(), ilogbl(): _BSD_SOURCE || _SVID_SOURCE || _XOPEN_SOURCE >= 600 || _ISOC99_SOURCE; or cc -std=c99

DESCRIPTION
These functions return the exponent part of their argument as a signed integer. When no error occurs, these functions are equivalent to the corresponding logb(3) functions, cast to int.

RETURN VALUE
On success, these functions return the exponent of x, as a signed integer. If x is zero, then a domain error occurs, and the functions return FP_ILOGB0. If x is a NaN, then a domain error occurs, and the functions return FP_ILOGBNAN. If x is negative infinity or positive infinity, then a domain error occurs, and the functions return INT_MAX.

ERRORS
See math_error(7) for information on how to determine whether an error has occurred when calling these functions.

The following errors can occur:

Domain error: x is 0 or a NaN
    An invalid floating-point exception (FE_INVALID) is raised.

    These functions do not set errno for this case.

Domain error: x is an infinity

    These functions do not set errno or raise an exception for this case.

CONFORMING TO
C99, POSIX.1-2001.

SEE ALSO
log(3), logb(3), significand(3)

COLOPHON
This page is part of release 3.19 of the Linux man-pages project. A description of the project, and information about reporting bugs, can be found at http://www.kernel.org/doc/man-pages/.